var ironcurtain = {}

ironcurtain.sortColumnIndex = 0;
ironcurtain.sortOrder = 'down';
ironcurtain.sortedColumnName = ''
ironcurtain.logResult = {}
ironcurtain.currentPage = 1;
ironcurtain.headers = [];
ironcurtain.queryingWidget = TABLE(null, 
                                TR(null, TD(null, IMG({'src': '/static/images/loading.gif'})),
                                         TD(null, SPAN({'class': 'previewLabel'}, 'Processing'))));
                            
ironcurtain.sortColumns = function(columnName, sortOrder)
{
    var i = 0;
    
    var rows = ironcurtain.headers
    
    while(i < rows.length && rows[i].column != columnName)
        i++;
    
    ironcurtain.sortColumnIndex = i;
    ironcurtain.sortOrder = sortOrder;

    ironcurtain.logResult['columns'].sort(ironcurtain.sortFn);
    ironcurtain.sortedColumnName = columnName
    
    ironcurtain.renderLogs(ironcurtain.logResult);
}

ironcurtain.sortFn = function(a, b)
{
    var index = ironcurtain.sortColumnIndex;
    var result = (ironcurtain.sortOrder == 'up') ? -1 : 1;
        
    if (a[index].value < b[index].value) 
        return result * -1;
    if (a[index].value > b[index].value)
        return result;
    return 0;
}

ironcurtain.retrieveLogs = function()
{
    var d = loadJSONDoc("/loginfo");
    ironcurtain.currentPage = 1;
    d.addCallback(ironcurtain.renderLogs);
}

ironcurtain.renderLogs = function(result)
{    
    if(result['message']) {
        alert(result['message']);
        replaceChildNodes('logs', '');
        return;
    }

    ironcurtain.logResult = result;
    
    var data = { 'headers': result['headers'],
                 'rows':result['columns'].slice(30 * (ironcurtain.currentPage - 1), 
                                                    30 * (ironcurtain.currentPage)),
                 'hidden_columns':['id'],
                 'sorted_column': ironcurtain.sortedColumnName,
                 'actions': { 
                    'sort': 'ironcurtain.sortColumns'
                  }
             };
    
    //if(result['selectFn'] != null)
    //    data['actions']['select'] = { 'function': result['selectFn'], 'params': [] };
             
    ironcurtain.headers = result['headers'];
    
    var grid = Widget.grid.render('user_log', data);
    
    var back, next;
    if(ironcurtain.currentPage == 1)
        back = 'Back';
    else
        back = A({'href': "javascript:ironcurtain.prevPage()", 
                                   'style': 'padding-right:1px'},
                                        'Back');
    
    if(ironcurtain.currentPage >= (ironcurtain.logResult['columns'].length / 30))
        next = 'Next'
    else
        next = A({'href': "javascript:ironcurtain.nextPage()",
                                   'style': 'padding-left:1px'}, 'Next');
    
    var backAndNext = DIV(null, back, (' Page ' + ironcurtain.currentPage + ' '), next);
    
    replaceChildNodes('logs', DIV({'align': 'center'}, grid, backAndNext));
}

ironcurtain.prevPage = function()
{
    if(ironcurtain.currentPage != 1)
        ironcurtain.currentPage -= 1;
    
    ironcurtain.renderLogs(ironcurtain.logResult);
}

ironcurtain.nextPage = function()
{
    if(ironcurtain.currentPage != (ironcurtain.logResult['columns'].length / 30))
        ironcurtain.currentPage += 1;
    
    ironcurtain.renderLogs(ironcurtain.logResult);
}

ironcurtain.sendQuery = function()
{
    var userName = document.getElementById("user").value;
    var groupName = document.getElementById("group").value;
    var url = document.getElementById("url").value;
    var startTime = document.getElementById("starttime").value;
    var endTime = document.getElementById("endtime").value;
    var i, begin = false;
    var arglst = [userName, groupName, url, startTime, endTime];
    var paramlst = ["user", "group", "url", "starttime", "endtime"];
    var queryString = ""

    for(i = 0; i < arglst.length; i++) {
        if(!arglst[i])
            continue;
        if(begin == false) {
            begin = true;
            queryString += paramlst[i] + "=" + escape(arglst[i]);
        } else {
            queryString += "&" + paramlst[i] + "=" + escape(arglst[i]);
        }
    }    
    
    var d = loadJSONDoc ("/loginfo?" + queryString);
    replaceChildNodes('logs', DIV({'align': 'center'}, ironcurtain.queryingWidget));
    d.addCallback(ironcurtain.renderLogs);
}

