var ironcurtain = {}

ironcurtain.loadingWidget = DIV(null, IMG({'src': '/static/images/loading.gif'}),
                                      SPAN({'class': 'previewLabel'}, 'Loading'));

ironcurtain.loadingRuleMenu = function(pluginName)
{
    return TABLE(null, TR(null, TD(null, ironcurtain.renderRuleMenu(pluginName))),
                       TR(null, TD(null, ironcurtain.loadingWidget)));
}

ironcurtain.highlightObject = function(objectName, listName)
{
    var el = document.getElementById(listName);
    var children = el.getElementsByTagName('a');
    for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if(child.getAttribute('id') == 'list_'+ objectName) {
            child.style.color = '#000'; 
            child.style.fontWeight= '900'; 
        } else {
            child.style.color = '#999'; 
            child.style.fontWeight= ''; 
        }
    }
}

ironcurtain.retrievePlugins = function()
{
    replaceChildNodes('rules', '');
    var d = loadJSONDoc("/pluginlist");
    d.addCallback(ironcurtain.renderPlugins);
}

ironcurtain.renderPlugins = function(result)
{
    var plugins = UL({'id':'plugin_list'});
    var pluginmenu = ironcurtain.renderPluginMenu();
    
    for(i in result['plugins']) {
        pluginName = result['plugins'][i]['name']
        var plugin = A({'id':'list_'+ pluginName, 
                        'href':"javascript:ironcurtain.displayRules('"+ pluginName +"')",
                        'title': result['plugins'][i]['description']}, pluginName);
        plugins.appendChild(LI({'itemID':pluginName, 'style': 'margin-top:5px'},
            plugin));
    }
    replaceChildNodes('plugins', DIV(null, pluginmenu, plugins));
    ironcurtain.menuSelect('pluginbrowse');
}

ironcurtain.renderPluginMenu = function()
{
    return  DIV
          (
            null,
            TABLE({'class':'detail_menu','cellpadding':'0','cellspacing':'0','border':'0'},
                TBODY(null,
                      TR(null,
                        TD({'id':'cell_pluginbrowse'},
                           A({'id':'link_pluginbrowse',
                              'title':'List available plugins',
                              'href':"javascript:ironcurtain.retrievePlugins()"},
                             'Browse')),
                        TD({'class':'spacing'}),
                        TD({'id':'cell_pluginadd','nowrap':'nowrap'},
                           A({'id':'link_pluginadd',
                              'title':'Add new plugin',
                              'href':"javascript:ironcurtain.renderPluginAdd()"},
                             'Add')),
                        TD({'class': 'spacing'}),
                        TD({'id':'cell_pluginremove', 'nowrap':'nowrap'},
                            A({'id':'link_pluginremove',
                               'title':'Delete a plugin',
                               'href':"javascript:ironcurtain.retrievePluginsRemove()"},
                            'Remove'))
                      )
                )
             )
          );
}

ironcurtain.renderPluginAdd = function()
{       
    var pluginadd = FORM({'action': '/addplugin', 'method': 'post', 'enctype': 'multipart/form-data'},
                            TABLE({'class':'detail_grid','cellpadding':'5'},
                                TR(null, TD({'valign':'top'}, 
                                            SPAN({'class': 'previewLabel'}, 'File')), 
                                            createDOM('INPUT', {'type':'file', 'name':'pluginFile'})),
                               createDOM('INPUT', {'type': 'submit', 'value':'Submit', 'class':'buts'})));
    
    var pluginmenu = ironcurtain.renderPluginMenu();
    
    replaceChildNodes('plugins', DIV(null, pluginmenu, pluginadd));
    ironcurtain.menuSelect('pluginadd');
    replaceChildNodes('rules', '');
}

ironcurtain.retrievePluginsRemove = function()
{
    replaceChildNodes('rules', '');
    var d = loadJSONDoc("/pluginlist");
    d.addCallback(ironcurtain.renderPluginsRemove);
}

ironcurtain.renderPluginsRemove = function(result)
{
    var plugins = UL({'id':'plugin_list'});
    var pluginmenu = ironcurtain.renderPluginMenu();
    
    for(i in result['plugins']) {
        pluginName = result['plugins'][i]['name']
        var plugin = A({'id':'list_'+ pluginName, 
                        'href':"javascript:ironcurtain.sendRemovePlugin('"+ pluginName +"')",
                        'title': result['plugins'][i]['description']}, pluginName);
        plugins.appendChild(LI({'itemID':pluginName, 'style': 'margin-top:5px'},
            plugin, A({'href':"javascript:ironcurtain.sendRemovePlugin('"+ pluginName +"')"},
                    IMG({'src':'/static/images/remove.png', 'border': '0'}))));
    }
    replaceChildNodes('plugins', DIV(null, pluginmenu, plugins));
    ironcurtain.menuSelect('pluginremove');    
}

ironcurtain.sendRemovePlugin = function(pluginName)
{
    if(!confirm("Are you sure you want to remove " + pluginName + "?"))
        return;
    
    var d = loadJSONDoc('/pluginremove?pluginName=' + pluginName);
    d.addCallback(ironcurtain.renderPluginsRemove);
}

ironcurtain.displayRules = function(pluginName)
{
    ironcurtain.retrieveRules(pluginName);
    
    ironcurtain.highlightObject(pluginName, 'plugin_list');
}

ironcurtain.retrieveRules = function(pluginName)
{
    var d = loadJSONDoc("/rulelist?pluginName=" + pluginName);
    replaceChildNodes('rules', ironcurtain.loadingWidget);
    d.addCallback(ironcurtain.renderRules);
}

ironcurtain.renderRules = function(result)
{
    var data = { 'headers': [{'column': 'id', 'label': 'ID'},
                             {'column': 'ruleName', 'label': 'Rule Name'}, 
                             {'column': 'description', 'label': 'Description'}], 
                 'rows':result['rules'],
                 'hidden_columns':['id'],
                 'actions':{
                          'edit':{'function':'ironcurtain.retrieveRuleEdit','params':[result['pluginName']]},
                          'remove':{'function':'ironcurtain.sendRemoveRule','params':[result['pluginName']]}
                          }
             };

    var grid = Widget.grid.render(result['pluginName'], data);
    
    var s = DIV(null,
                ironcurtain.renderRuleMenu(result['pluginName']),
                grid
              );
    
    replaceChildNodes('rules', s);
  
    ironcurtain.menuSelect('rulebrowse');
}

ironcurtain.sendRemoveRule = function(pluginName, ruleId)
{
    if(!confirm("Are you sure you want to remove this rule?"))
        return;
    var d = postJSONDoc('/removerule','pluginName='+pluginName+'&ruleId='+ ruleId);
    d.addCallback(ironcurtain.removeRuleSent);
}

ironcurtain.removeRuleSent = function(result)
{
    ironcurtain.displayRules(result['plugin']);
}

ironcurtain.retrieveRuleEdit = function(pluginName, ruleId)
{
    var d = loadJSONDoc("/ruleinfo?pluginName=" + pluginName + "&ruleId=" + ruleId);
    replaceChildNodes('rules', ironcurtain.loadingRuleMenu());
    d.addCallback(ironcurtain.renderRuleEdit);
}

ironcurtain.renderRuleEdit = function(result)
{
    var pluginName = result['pluginName'];

    var cancelButton = ironcurtain.renderButton('btnCancel',
                                          'Cancel',
                                          'ironcurtain.displayRules(' + "'" + pluginName + "'" + ')',
                                          'Cancel'
                                          );

    var updateButton = ironcurtain.renderButton('btnUpdate',
                                    'Update',
                                    "ironcurtain.retrieveRuleUpdate('"+ pluginName +"',"+ result['ruleId'] +")",
                                    'Update'
                                    );

    var formEdit = createDOM('DIV',null,
                            ironcurtain.renderRuleMenu(pluginName) ,
                            ironcurtain.renderRuleColumns(result['plugin'], 
                                                          result['rule'],
                                                          result['ruleName'], 
                                                          result['ruleDesc'],
                                                          result['ruleId']),
                            cancelButton,
                            updateButton
                          );
  replaceChildNodes('rules',formEdit);
}

ironcurtain.retrieveRuleUpdate = function(pluginName, ruleId)
{
    var postVars = ironcurtain.collectPostVars(document.myform);
    postVars+= '&pluginName='+ pluginName +'&ruleId='+ ruleId;

    var d = postJSONDoc('/updaterule', postVars); 
    d.addCallback(ironcurtain.renderRuleUpdateOrSave);

}

ironcurtain.retrieveRuleSave = function(pluginName)
{
    var postVars = ironcurtain.collectPostVars(document.myform);
    postVars+= '&pluginName='+ pluginName;

    var d = postJSONDoc('/updaterule', postVars); 
    d.addCallback(ironcurtain.renderRuleUpdateOrSave);

}

ironcurtain.renderRuleUpdateOrSave = function(result)
{
    if(result['error_message']) {
        alert(result['error_message']);
        ironcurtain.displayRules(result['pluginName']);
    } else {
        ironcurtain.displayRules(result['pluginName']);
    }
}

ironcurtain.renderButton = function(btnId, label, action, title)
{
    var props = {'class':'buts',
                 'id':btnId,
                 'onclick':action 
                };
                
    if(Widget.exists(title)) 
        props['title'] = title;

    return createDOM('BUTTON', props, label);
}

ironcurtain.renderRuleColumns = function(plugin, rule, ruleName, ruleDesc, ruleId)
{
    var columns = TBODY(null);
    var columnValue;
    
    var ruleNameCol = ironcurtain.renderStringCol("ruleName", ruleName); 
    var ruleDescCol = ironcurtain.renderStringCol("ruleDesc", ruleDesc, 50);
    
    columns.appendChild(TR(null, TD({'valign':'top'},
                                  SPAN({'class':'previewLabel'}, "Name")), 
                                  ruleNameCol));
    
    columns.appendChild(TR(null, TD({'valign':'top'},
                                  SPAN({'class':'previewLabel'}, "Description")), 
                                  ruleDescCol));

    for(var i = 0; i < plugin.length; i++) {
        if(rule != null)
            columnLabel = rule[plugin[i][0]];
        else
            columnLabel = null;
            
        switch(plugin[i][2]) {
            case 'enum':
                columnValue = ironcurtain.renderEnumCol(plugin[i], columnLabel);
                break;
            case 'string':
                columnValue = ironcurtain.renderStringCol(plugin[i][0], columnLabel);
                break;
            //TODO: NEED MORE!!!!!
        }
        columns.appendChild(TR(null, TD({'valign':'top'},
                                        SPAN({'class':'previewLabel'}, plugin[i][1])), 
                                        columnValue ));
    }
    
    if(ruleId != null) {
        var ruleJoins = [["appliedUsers", "Applied Users"], 
                         ["appliedGroups", "Applied Groups"],
                         ["appliedTags", "Applied Tags"]];

        var joins = TBODY(null);
    
        for(var i = 0; i < ruleJoins.length; i++) {
            joins.appendChild(TR(null, TD({'valign': 'top'}, 
                                        A({'href': "javascript:ironcurtain.retrieveJoins('" + 
                                               ruleJoins[i][0] + "', '" + ruleId + "')"},
                                            IMG({'border':'0','style':'margin-right:5px','align':'bottom',
                                                 'src': '/static/images/arrow_down.png', 
                                                 'id': 'img_' + ruleJoins[i][0]})),
                                       SPAN({'class':'previewLabel'}, ruleJoins[i][1]))));
            joins.appendChild(TR({'valign': 'top'}, DIV({'id': 'join_table_' + ruleJoins[i][0]})));
        }
        
        var urlMatch = TBODY(null, TR(null, TD({'valign': 'top'},
                                    A({'href': "javascript:ironcurtain.retrieveURLMatch('" + ruleId + "', true)"},
                                        IMG({'border':'0','style':'margin-right:5px','align':'bottom',
                                                 'src': '/static/images/arrow_down.png', 
                                                 'id': 'img_match_url'})),
                                        SPAN({'class':'previewLabel'}, "Applied URLs"))),
                      TR({'valign': 'top'}, DIV({'id': 'match_url_table'})));
        
        var urlNotMatch = TBODY(null, TR(null, TD({'valign': 'top'},
                            A({'href': "javascript:ironcurtain.retrieveURLMatch('" + ruleId + "', false)"},
                                IMG({'border':'0','style':'margin-right:5px','align':'bottom',
                                            'src': '/static/images/arrow_down.png', 
                                            'id': 'img_not_match_url'})),
                                SPAN({'class':'previewLabel'}, "Not Applied URLs"))),
                TR({'valign': 'top'}, DIV({'id': 'not_match_url_table'})));    

        return TABLE(null, TR(null, TABLE({'class':'detail_grid','cellpadding':'5'}, columns)),
                           TR(null, TABLE({'class':'detail_grid','cellpadding':'5'}, joins)),
                           TR(null, TABLE({'class':'detail_grid','cellpadding':'5'}, urlMatch)),
                           TR(null, TABLE({'class':'detail_grid','cellpadding':'5'}, urlNotMatch)));
    }
    
    return TABLE(null, TR(null, TABLE({'class':'detail_grid','cellpadding':'5'}, columns)));
}

ironcurtain.retrieveURLMatch = function(ruleId, value)
{
    var valstr = value ? '' : 'not_';
    var el = document.getElementById('img_' + valstr + 'match_url');
    
    if(el.getAttribute('src') == '/static/images/arrow_down.png') {
        var d = loadJSONDoc('/ruleurlinfo?match=' + (value ? 'True' : 'False') + '&ruleId=' + ruleId);
        replaceChildNodes(valstr + 'match_url_table', ironcurtain.loadingWidget);
        el.setAttribute('src', '/static/images/arrow_right.png');
        d.addCallback(ironcurtain.renderURLMatch);
    } else {
        el.setAttribute('src', '/static/images/arrow_down.png');
        replaceChildNodes(valstr + 'match_url_table', '');
    }   
}

ironcurtain.renderURLMatch = function(result)
{
    var applied = (result['applied'] == 'true') ? true : false;
    var valstr = applied ? '' : 'not_';
    var urlMatch = createDOM('SELECT',
                             {'id':'select_' + valstr + 'match_url', 
                             'size':'10','style':'width:225px','multiple':'multiple'}, 
                              map(ironcurtain.renderJoinElements, result['urls']));

    var addNewField = createDOM('INPUT', {'type': 'text',
                                          'name': 'newURL', 'id': valstr + 'match_url_add_new'});
    var addWidget = Widget.iconLabel.render('add',
                                            'Add',
                                            'javascript:ironcurtain.addURL',
                                            [applied]);
    var removeSelectedWidget = Widget.iconLabel.render('remove',
                                                       'Remove Selected',
                                                       'javascript:ironcurtain.removeSelectedURLs',
                                                       [applied]);

    var saveWidget = Widget.iconLabel.render('save',
                                             'Save',
                                             'javascript:ironcurtain.saveURLs',
                                             [result['ruleId'], applied]);

    var urlMatchTable = TABLE(null, TBODY(null,
        TR(null, TD({'style':'border:none'},
                     SPAN({'class': 'previewLabel'}, 'Current URLs'))),
        TR(null, TD({'style':'border:none'}, urlMatch, removeSelectedWidget)),
        TR(null, TD(null,
                    SPAN({'class': 'previewLabel'}, 'New URL '), addNewField, addWidget, saveWidget))));
        

    replaceChildNodes(valstr + 'match_url_table', urlMatchTable);
}

ironcurtain.addURL = function(applied)
{
    var valstr = ((applied == 'true') ? '' : 'not_');
    var el = document.getElementById(valstr + 'match_url_add_new');
    Widget.select.addListToDestination([el.value], document.getElementById('select_' + valstr + 'match_url'));
}

ironcurtain.removeSelectedURLs = function(applied)
{
    var valstr = ((applied == 'true') ? '' : 'not_');    
    var list = document.getElementById('select_' + valstr + 'match_url');
    Widget.select.removeSelectedOptions(list);
}

ironcurtain.saveURLs = function(ruleId, applied)
{
    var valstr = ((applied == 'true') ? '' : 'not_');   
    var params = 'ruleId=' + ruleId + '&match=' + ((applied == 'true') ? 'True' : 'False');
    params +='&urls=' + Widget.select.getOptionValuesAsCSV(document.getElementById('select_' + valstr + 'match_url'));

    var e = postJSONDoc('/ruleurlupdate', params);
    e.addCallback(ironcurtain.renderRuleEdit);
}

ironcurtain.retrieveJoins = function(joinName, ruleId)
{
    var el = document.getElementById('img_' + joinName);
    var params = '?joinName=' + joinName;
    
    if(ruleId != null)
        params += '&ruleId=' + ruleId
    
    if(el.getAttribute('src') == '/static/images/arrow_down.png') {
        var d = loadJSONDoc('/rulejoininfo' + params);
        replaceChildNodes('join_table_' + joinName, ironcurtain.loadingWidget);
        d.addCallback(ironcurtain.renderJoins);
        el.setAttribute('src', '/static/images/arrow_right.png');
    } else {
        el.setAttribute('src', '/static/images/arrow_down.png');
        replaceChildNodes('join_table_' + joinName, '');
    }   
}

ironcurtain.renderJoins = function(result) 
{
    var thisJoins = createDOM('SELECT',
                                {'id':'select_remove_'+ result['joinName'],
                                 'size':'10','style':'width:225px','multiple':'multiple'}, 
                                map(ironcurtain.renderJoinElements, result['thisJoins']));

    var allJoins = createDOM('SELECT',
                                {'id':'select_add_'+ result['joinName'],
                                 'size':'10','style':'width:225px','multiple':'multiple'}, 
                                map(ironcurtain.renderJoinElements, result['allJoins']));
                                

    var joinTable = TABLE(null, TBODY(null,
        TR(null, TD({'style':'border:none'},
                     SPAN({'class': 'previewLabel'}, 'Current ' + result['name'])),
                 TD({'style':'border:none'},
                     SPAN({'class': 'previewLabel'}, 'All ' + result['name']))),
        TR(null, TD({'style':'border:none'}, thisJoins),
                 TD({'style':'border:none'}, allJoins)),
        TR(null, TD({'style':'border:none'},
                    Widget.iconLabel.render('remove',
                                            'Remove Selected',
                                            'javascript:ironcurtain.removeSelectedJoins',
                                            [result['joinName']])),
                TD({'style':'border:none'},
                    Widget.iconLabel.render('add',
                                            'Add Selected',
                                            'javascript:ironcurtain.addSelectedJoins',
                                            [result['joinName']]))),
        TR(null, TD({'colspan': '2', 'align':'right'},
                    Widget.iconLabel.render('save',
                                            'Save',
                                            'javascript:ironcurtain.saveJoins',
                                            [result['joinName'], result['ruleId']])))));

    replaceChildNodes('join_table_' + result['joinName'], joinTable);
}

ironcurtain.renderJoinElements = function(ele)
{
    return createDOM('OPTION', {'label': ele}, ele);
}

ironcurtain.saveJoins = function(joinName, ruleId)
{
  var params = 'joinName=' + joinName +'&ruleId=' + ruleId;
  params +='&joins=' + Widget.select.getOptionValuesAsCSV(document.getElementById('select_remove_'+ joinName));

  var e = postJSONDoc('/rulejoinupdate', params);
  e.addCallback(ironcurtain.renderRuleEdit);
}

ironcurtain.removeSelectedJoins = function(joinName)
{
  var list = document.getElementById('select_remove_'+ joinName);
  Widget.select.removeSelectedOptions(list);
}

ironcurtain.addSelectedJoins = function(joinName)
{
  var src = document.getElementById('select_add_'+ joinName);
  var dest = document.getElementById('select_remove_'+ joinName);
  Widget.select.addSelectedOptionsFromSourceToDestination(src,dest);
}

ironcurtain.renderStringCol = function(label, value, maxlength)
{
    var fieldopts = {'class':'txtfield', 'type':'text', 
                     'name': label,
                     'maxlength': (maxlength != null) ? maxlength : ''};

    if(value != null && value.length != null && value.length > 0)
        fieldopts['value'] = value;
    
    return TD(null, createDOM('INPUT', fieldopts));
}

ironcurtain.renderEnumCol = function(plugcol, rulecol)
{
    var column = {'options': []};
    
    for(var i = 0; i < plugcol[3].length; i++) {
        column['options'][i] = {
                         'selected':rulecol != null ? (rulecol == plugcol[3][i]) : false,
                         'value': plugcol[3][i],
                         'label': plugcol[3][i]
                        }
  }
  return TD(null, 
            createDOM('SELECT',
                      {'name':plugcol[0]},
                      map(ironcurtain.renderOptions, column['options']) 
                     ) 
           );
}

ironcurtain.renderOptions = function(option)
{
    if(option.selected) 
        return createDOM('OPTION',{'value':option.value,'selected':'selected'}, option.label);
  return createDOM('OPTION',{'value':option.value},option.label);
}

ironcurtain.menuSelect = function(menu_item)
{
    document.getElementById('cell_'+ menu_item).style.backgroundColor='#999';
    document.getElementById('link_'+ menu_item).style.color='#fff';
}

ironcurtain.retrieveRuleAdd = function(pluginName)
{
    var d = loadJSONDoc('/ruleinfo?pluginName=' + pluginName);
    replaceChildNodes('rules', ironcurtain.loadingRuleMenu());
    d.addCallback(ironcurtain.renderRuleAdd);
}

ironcurtain.renderRuleAdd = function(result)
{
    var pluginName = result['pluginName'];
    
    var cancelButton = ironcurtain.renderButton('btnCancel',
                                          'Cancel',
                                          'ironcurtain.displayRules(' + "'" + pluginName + "')",
                                          'Cancel'
                                          );

    var updateButton = ironcurtain.renderButton('btnSave',
                                    'Save',
                                    'ironcurtain.retrieveRuleSave(' + "'" + pluginName + "')", 
                                    'Save'
                                    );

    var formAdd = createDOM('DIV',null,
                            ironcurtain.renderRuleMenu(pluginName) ,
                            ironcurtain.renderRuleColumns(result['plugin'], 
                                                          null, 
                                                          result['ruleName'], 
                                                          result['ruleDesc'],
                                                          null
                                                          ),
                            cancelButton,
                            updateButton
                          );
                          
    replaceChildNodes('rules',formAdd);
    ironcurtain.menuSelect('ruleadd');   
}

ironcurtain.collectPostVars = function(f)
{
    var postVars='';
    
    for(var i=0; i < f.elements.length; i++) {
        var t = f.elements[i].type;
        if(t.indexOf('text') > -1 ) {
            if(postVars!='')
                postVars+='&';
            postVars+= f.elements[i].name +'='+ encodeURIComponent(f.elements[i].value);
        }
        if(t.indexOf('select') > -1) {
              if(postVars!='') postVars+='&';
              postVars+= f.elements[i].name + '=' 
                            + f.elements[i].options[f.elements[i].selectedIndex].value;
        }
    }
    
    return postVars;
}

ironcurtain.renderRuleMenu = function(pluginName)
{
  return  DIV
          (
            null,
            TABLE({'class':'detail_menu','cellpadding':'0','cellspacing':'0','border':'0'},
                TBODY(null,
                      TR(null,
                        TD({'id':'cell_rulebrowse'},
                           A({'id':'link_rulebrowse',
                              'title':'List available rules',
                              'href':"javascript:ironcurtain.retrieveRules('"+ pluginName +"')"},
                              'Browse')),
                        TD({'class':'spacing'}),
                        TD({'id':'cell_ruleadd','nowrap':'nowrap'},
                           A({'id':'link_ruleadd',
                              'title':'Add new rule',
                              'href':"javascript:ironcurtain.retrieveRuleAdd('"+ pluginName +"')"},
                              'Add')),
                        TD({'class':'spacing','style':'width:300px'})
                      )
                )
             )
          );
}

function postJSONDoc(url, postVars)
{
  var req = getXMLHttpRequest();
  req.open('POST', url, true);
  req.setRequestHeader('Content-type','application/x-www-form-urlencoded');
  var d = sendXMLHttpRequest(req, postVars);
  return d.addCallback(evalJSONRequest);
}
