import re
from BeautifulSoup import BeautifulSoup, Null

from constants import *

class ModifyJavascript:
    Args = [ ("TagName", "Tag Name", "string" ),
             ("RepValue", "Replace Value", "string")
             ]
             
    Desc = "Modifies javascript"
    
    ApplyTime = AFTER_BODY
    
    def __init__(self, params):
        self.params = params
    
    def act_on_req(self, cReq):
        return ACTION_FORWARD, ""
    
    def act_on_res(self, cRes):
        if cRes.content_header and re.match("text\/(html|xhtml)", cRes.content_header):
            self.modify_javascript(cRes.js_outputs)   
        return ACTION_FORWARD, ""
    
    def modify_javascript(self, js_outputs):
        for ii in xrange(len(js_outputs)):
            html_parser = BeautifulSoup()
            try:
                html_parser.feed(js_outputs[ii])
            except:
                continue
            tags = html_parser.fetch(self.params["TagName"])
            for tag in tags:
                tag.name = self.params["RepValue"]
            
            js_outputs[ii] = str(html_parser)
           

