from sqlobject import SQLObjectNotFound

from model import ICUser, ICGroup

userMap = {}

def check_if_auth(ip):
    """Checks if the user with the IP address given as parameter is logged in. Returns the id or None"""
    if userMap.has_key(ip):
        return userMap[ip]
    return None

def login_user_with_ip(ip, userId):
    """Authenticates and associates the given id with then given IP address"""
    try:
        user = ICUser.byUserName(userId)
        userMap[ip] = user.id
    except SQLObjectNotFound:
        pass

def get_user_name_from_ip(ip):
    return ICUser.get(userMap[ip]).userName

def logout_user(ip, userName):
    """Logs out the user with the given IP address"""
    try: user = ICUser.byUserName(userName)
    except SQLObjectNotFound: return False
    
    if userMap.has_key(ip) and userMap[ip] == user.id: 
        del userMap[ip]
        return True
    return False
