# -*- coding: utf-8 -*-
 
import urlparse, urllib, re
from constants import *

class HTTPRequestLine:
    """ It parses first line of HTTP request(like GET / HTTP/1.1)"""
    def __init__(self, l):
        llist = l.split(' ')
        #self.method = find_method(llist[0])
        self.method = llist[0]
        (self.scheme, self.netloc, self.path, 
          self.query, self.fragment) = urlparse.urlsplit(llist[1])
        self.uri = llist[1]
        self.version = llist[2]
    def full_path(self):
        fpath = self.path
        if(self.query != ''):
            fpath += '?' + self.query
        if(self.fragment != ''):
            fpath += '#' + self.fragment
        return fpath
    def __str__(self):
        return str(self.method) + ' ' + self.scheme + ' ' + self.netloc + ' ' + self.full_path() + ' ' + self.version
    
class HTTPRequest:
    """ It parses the HTTP request and stores it """
    def __init__(self, rlist, userid):
        """This function parses the HTTP request """
        self.line = HTTPRequestLine(rlist[0])
        self.uid = userid
        rhl = []
        for i in rlist[1:]:
            rhl.append(i.split(": "))
        self.headers = {}
        for i in rhl:
            self.headers[i[0]] = i[1].lower()
        self.body = ""
        
    def serialize(self):
        seristring = str(self.line)
        for i in self.headers.items():
            seristring += i[0].title() + ": " + i[1] + "\r\n"
        seristring += "\r\n" + self.body
        return seristring
        
    def get_header(self, headerName):
        lcheader = headerName.lower()
        if self.headers.has_key(lcheader):
            return self.headers[lcheader]
        else:
            return None
    
    def replace_header(self, headerName, headerValue):
        self.headers[headerName.lower()] = headerValue
        
    def delete_header(self, headerName, headerValue):
        lcheader = headerName.lower()
        if self.headers.has_key(lcheader):
            if headerValue == "" or headerValue == self.headers[lcheader]:
                del self.headers[lcheader]
    
