from sqlobject import *
from config import DB_URI

class ICPlugin(SQLObject):
    _connection = DB_URI
    pluginName = StringCol(length = 30, alternateID=True)
    applyTime = IntCol()
    arguments = PickleCol()
    description = StringCol(length = 50)

class ICRule(SQLObject):
    _connection = DB_URI    
    ruleName = StringCol(length = 30)
    description = StringCol(length = 50)
    plugin = ForeignKey('ICPlugin')
    parameters = PickleCol()
    appliedUsers = RelatedJoin('ICUser')
    appliedGroups = RelatedJoin('ICGroup')
    appliedTags = RelatedJoin('ICTag')
#    notappliedTags = RelatedJoin('ICTag')
    appliedURLs = PickleCol() #List of strings
    notappliedURLs = PickleCol() #List of strings

class ICTag(SQLObject):
    _connection = DB_URI    
    tagName = StringCol(length = 16, alternateID = True)
    tagDesc = StringCol(length = 50)
    rules = RelatedJoin('ICRule')

#class ICSite(SQLObject):
#    siteName = StringCol(alternateID = True)
    
class ICUser(SQLObject):
    _connection = DB_URI    
    userName = StringCol(length = 16, alternateID = True)
    password = StringCol(length = 16)
    displayName = UnicodeCol()
    email= StringCol()
    rules = RelatedJoin('ICRule')
    groups = RelatedJoin('ICGroup')

class ICGroup(SQLObject):
    _connection = DB_URI
    groupName= StringCol(length = 16, alternateID = True)
    displayName= StringCol()
    users = RelatedJoin('ICUser')
    rules = RelatedJoin('ICRule')
    permissions = RelatedJoin('ICPermission')

class ICBandwidth(SQLObject):
    _connection = DB_URI    
    user = ForeignKey('ICUser')
    date = DateCol()
    totalBandwidth = IntCol()

class ICSecretToken(SQLObject):
    _connection = DB_URI    
    userId = StringCol(length = 16, alternateID = True)
    value = StringCol(length = 40)

class ICPermission(SQLObject):
    _connection = DB_URI    
    permissionName = StringCol(length = 16, alternateID=True)
    description = StringCol(length= 255)

class ICUserLog(SQLObject):
    _connection = DB_URI    
    user = ForeignKey('ICUser')
#    site = ForeignKey('ICSite')
    location = StringCol()
    inBandwidth = IntCol()
    outBandwidth = IntCol()
    urlType = StringCol()
    requestTime = DateTimeCol()

#class ICRuleLog(SQLObject):
#    _connection = DB_URI
#    rule = ForeignKey('ICRule')
#    site = ForeignKey('ICSite')
#    location = StringCol()
#    actionTime = DateTimeCol()
#    actionDesc = StringCol(length = 8)
