from constants import *
from model import ICBandwidth
import datetime
from sqlobject import *


class BandwidthLimiter:
    
    Args = [("Limit", "Limit", "string"),
            ("Size", "Size", "enum", ("GB","MB")),
            ("Period", "Period", "enum", ("Daily", "Weekly", "Monthly"))]
    Desc = ""
    
    ApplyTime = BEFORE_BODY
    
    def __init__(self, params):
        
        self.params = params
        
        self.limit = int(self.params["Limit"]);
        if self.params["Size"] == "GB":
            self.limit = self.limit * 1024 * 1024
        elif self.params["Size"] == "MB":
            self.limit = self.limit * 1024 
        
        self.day_count = 0
        if self.params["Period"] == "Weekly":
            self.day_count = 7
        elif self.params["Period"] == "Monthly":
            self.day_count = 31

        
    def act_on_req(self, cReq):
        
        totalbw = 0
        try:
            user_bandw = ICBandwidth.select(
                         AND(ICBandwidth.q.userID == cReq.uid, 
                             ICBandwidth.q.date == datetime.datetime.today().replace(microsecond=0,
                                                                                     second=0,
                                                                                     minute=0,
                                                                                     hour=0)))[0]
            totalbw = user_bandw.totalBandwidth
        except:
            print "Unhandled exception in BwLimiter"
            return ACTION_FORWARD    
            
        
        for i in range(1,self.day_count): 
            try:
                dt = (datetime.datetime.today() - datetime.timedelta(i)).replace(microsecond=0, second=0,minute=0,hour=0)
                user_bandw = ICBandwidth.select(
                                            AND(ICBandwidth.q.user == cReq.uid,
                                                ICBandwidth.q.date == dt))[0]
                        
                totalbw = totalbw + user_bandw.totalBandwidth
            except:
                print "exception occurred in BwLimiter for loop"
                continue
                   
        if user_bandw.totalBandwidth > self.limit:
            return ACTION_BLOCK
        
        return ACTION_FORWARD
    
    def act_on_res(self, cRes):
        # same procedure for response
        self.act_on_req(cRes);
