from constants import *
from BeautifulSoup import *

class ModifyContent:
    
    Args = [("Action", "Action", "enum", ("Remove", "Replace", "Block")), 
             ("TagName", "Tag Name", "string" ),
             ("AttName", "Attribute Name", "string"),
             ("AttValue", "Attribute Value", "string"),
             ("EncBlock", "Enclosing Block", "string"),
             ("ActPart", "Action on Part", "enum", ("Tag Name", "Attribute Name", "Attribute Value", "Enclosing Block")), 
             ("RepValue", "Replace Value", "string")
             ]
    
    Desc = "Modifies HTML content"
    
    ApplyTime = AFTER_BODY

    def __init__(self, params):
        self.params = params
        #sadece bir tanesi icin calisiyor burasi degisecek
        self.attributes =  {}
        self.attributes[params["AttName"]] = re.compile(params["AttValue"])
    
    def act_on_req(self, cReq):
        return ACTION_FORWARD
    
    def act_on_res(self, cRes):
        action = ACTION_FORWARD
        if(re.match("text\/(html|xhtml)", cRes.get_header("content-type"))):
            cRes.body, action = self.modify_content(cRes.body)
        
        return action
            
    def modify_content(self, html_parser): 
        objects = []
        encBlock = self.params["EncBlock"]
        if encBlock != "":
            objects2 = html_parser.fetch(encBlock)
            for i in objects2:
                objects += i.fetch(self.params["TagName"],self.attributes)
        else:
            objects = html_parser.fetch(self.params["TagName"],self.attributes) 

        # Action on Attribute Name or Value 
        if self.params["ActPart"] == "Attribute Name" or self.params["ActPart"] == "Attribute Value":
            print "Attribute Value or Name"
            if self.params["Action"] == "Remove":
                for i in objects:
                    i.__delitem__(self.params["AttName"])
                            
            elif self.params["Action"] == "Replace":
                print "Replace"
                if self.params["ActPart"] == "Attribute Name":
                    for i in objects:
                        tmp = i[self.params["AttName"]]
                        i[self.params["AttName"]] = Null
                        i[self.params["RepValue"]] = tmp     
                else:
                    for i in objects:
                        i[self.params["AttName"]] = self.params["RepValue"]
                        print "i zimbirtisi", i[self.params["AttName"]]
            elif self.params["Action"] == "Block":
                if len(objects) != 0:
                    return html_parser, ACTION_BLOCK
                return html_parser, ACTION_FORWARD
                
            return html_parser, ACTION_FORWARD

        items = []

        # Action on Tag Name or Enclosing Block        
        #find items to change
        if self.params["ActPart"] == "Tag Name":
            items = objects

        elif self.params["ActPart"] == "Enclosing Block":
            for i in objects:
                obj = i.parent
                while obj != Null:
                    if obj.name == encBlock:
                        items.append(obj)
                        break 
                    obj = obj.parent
        
        if self.params["Action"] == "Remove":        
            for i in items:
                i.attrs = Null
                i.contents = Null
                i.name = "SPAN"
            
        elif self.params["Action"] == "Replace":
            for i in items:
                i.name = params["RepValue"]
                   
        elif self.params["Action"] == "Block":
            if len(items) != 0:
                return html_parser, ACTION_BLOCK
            return html_parser, ACTION_FORWARD
                        
        return html_parser, ACTION_FORWARD

    
                
            
